% Generates UV-compatible dataset that includes extensive margin (for
% Figures A1-A2)

clear all
load ../Data/dataAER_RR allLVAdata_DONOT_dropIN_4secUV
MTX=allLVAdata_DONOT_dropIN_4secUV;
load ../Data/PandQdata_4secUV
hs=9;
obs=(size(MTX,2)-hs)/2;

prodlev=4;%product level
MTX(:,2)=floor(MTX(:,2)/(10^(4-prodlev)));
m=0;%store type
j=0.1*10^prodlev:floor(0.999999*10^prodlev);
DATAMTX=DATAMTX(DATAMTX(:,3)==m,:);
DATAMTXsum=DATAMTXsum(DATAMTXsum(:,2)==m,:);
DATAMTX=DATAMTX(ismember(DATAMTX(:,2),j),:);
DATAMTXsum=DATAMTXsum(ismember(DATAMTXsum(:,1),j),:);
MTX=MTX(nansum(MTX(:,hs+obs+1:end),2)>0,:);
seclist=unique(DATAMTX(:,2));
G=length(seclist);
N=size(MTX,1);
Q=MTX(:,hs+1:hs+obs);
P=MTX(:,hs+obs+1:hs+2*obs);

%compute # of obs and items per group
MTX=[MTX(:,1:hs) Q P];
for i=1:G
    temp=MTX(ismember(MTX(:,2),seclist(i)),:);
    Qtemp=temp(:,hs+2:hs+obs)-temp(:,hs+1:hs+obs-1);
    Ptemp=DATAMTX(DATAMTX(:,2)==seclist(i),4)';
    Ptemp=exp(cumsum([1 Ptemp(2:end)],2));
    Ptemp=repmat(Ptemp(2:end),size(Qtemp,1),1);
    temp3=~isnan(Qtemp.*Ptemp);
    obs_cnt(i,1)=sum(sum(temp3));
    item_cnt(i,1)=sum(sum(temp3,2)>0);
end
DATAMTXsum(:,13:14)=[obs_cnt item_cnt];


%%%%%%%%%%%%%%%%%
%prepare data
%%%%%%%%%%%%%%%%%
KEEP=sum(DATAMTXsum(ismember(DATAMTXsum(:,1),seclist),3));
G=length(seclist);
N=size(MTX,1);
Q=MTX(:,hs+1:hs+obs);
P=MTX(:,hs+obs+1:hs+2*obs);
R=Q.*P;

Ri1=R(:,1:19);
Xi1=reshape(Ri1,N*19,1);
Ri2=R(:,2:20);
Xi2=reshape(Ri2,N*19,1);
time=repmat(1:19,N,1);
time=reshape(time,N*19,1);

grp=repmat(MTX(:,2),19,1);
ctry_id=repmat(MTX(:,9),19,1);
itm_id=repmat(MTX(:,8),19,1);
store_id=repmat(MTX(:,1),19,1);

%save ../Data/data_4digit_extmargin grp time itm_id store_id ctry_id Xi1 Xi2

