%This code generates Figure 1
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear all
load Data/LVmacrodata

FS=8;%FontSize
LW=2;%LineWidth
tline=2006:0.25:2011.5;

h=figure;
subplot(2,2,1), plot(tline,log(realY),'-',tline,NX_Y,'-.','LineWidth',LW)
set(gca,'FontSize',FS)
title('(a) GDP and net trade')
hline(0,'k-')
xlim([2006 2011.5])
ylim([-0.35 0.15])
ylabel('Index & share of GDP')
text(2007,-0.26,'NX/GDP','FontSize',FS) 
text(2007.5,0.05,'Real GDP','FontSize',FS) 

subplot(2,2,2), plot(tline,log(M_Y),'-',...
    tline,log(X_partnY),'-.','LineWidth',LW)
set(gca,'FontSize',FS)
title('(b) Imports and exports')
hline(0,'k-')
xlim([2006 2011.5])
ylim([-0.35 0.15])
ylabel('Index (2007Q1=0)')
text(2009.7,-0.3,'M/GDP','FontSize',FS)  
text(2008.1,0.06,'X/partner GDP','FontSize',FS) 

%renormalize effective price indexes
REER=REER./REER(11); %6=2007Q1
NEER=NEER./NEER(11);

subplot(2,2,3.5), plot(tline,log(NEER),'-',tline,log(REER),'-.',...
    'LineWidth',LW)
set(gca,'FontSize',FS)
title('(c) Relative price adjustment')
hline(0,'k-')
xlim([2006 2011.5])
ylim([-0.35 0.15])
ylabel('Index (2008Q2=0)')
text(2006.4,-0.07,'NEER','FontSize',FS) 
text(2006.5,-0.22,'REER','FontSize',FS)
text(2008.5,-0.1,'$\uparrow $ Appreciation','Interpreter','Latex')