%This code generates Figure 10, Panel (a)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clear all
load Data/dataAER_RR

MTX=allLVAdata_dropIN_4secUV;
MTX=MTX(ismember(MTX(:,9),[101 941]),:);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
hs=9;
T=(size(MTX,2)-hs)/2;
P=MTX(:,hs+T+1:hs+2*T);
Q=MTX(:,hs+1:hs+T);
Rmtx=P.*Q;
R_ALL=nansum(Rmtx,1)';

prodlev=4;%choose sectoral detail
list=floor(1000/(10^(4-prodlev))):floor(9999/(10^(4-prodlev)));

g=0;
for ProdDef=list%list of feasible sectors
    
    %restrict MTX to the particular product
    MCtree_X=ProdDef*(10^(4-prodlev)):...
        ProdDef*(10^(4-prodlev))+floor(0.9999*(10^(4-prodlev)));
    MTX2=MTX(ismember(MTX(:,2),MCtree_X),:);
    
    if ~isempty(MTX2)==1%proceed only if MTX not empty
        
        Q=MTX2(:,hs+1:hs+T);
        P=MTX2(:,hs+T+1:hs+2*T);
        Rmtx=P.*Q;
        
        g=g+1;
        for t=1:T-1
            cid=find(~isnan(P(:,t).*P(:,t+1)));
            ovlp=length(cid);
            
            %quantities
            %%%%%%%%%%%%%%%%%%
            Q_c=Q(cid,[t t+1]);
            sumQ_c=sum(Q_c,1);
            Qw_c=Q_c./repmat(sumQ_c,[ovlp,1]);
            
            %agg unit values
            %%%%%%%%%%%%%%%%%%
            P_c=P(cid,[t t+1]);
            agguvP_c=sum(Qw_c.*P_c,1);
            Pdev_c=P_c./repmat(agguvP_c,[ovlp,1]);%centered on 1
            
            %expenditure shares
            %%%%%%%%%%%%%%%%%%%%
            R_c=Rmtx(cid,[t t+1]);
            sumR_c=sum(R_c,1);
            Rw_c=R_c./repmat(sumR_c,[ovlp,1]);
            
            %item-level indexes
            %%%%%%%%%%%%%%%%%%%%
            IDX_Q(g,t)=sum(log(Qw_c(:,2)./Qw_c(:,1)).*log(Pdev_c(:,1)),1);
            IDX_P(g,t)=sum(log(P_c(:,2)./P_c(:,1)).*log(Pdev_c(:,1)),1);
            R_grp(g,t)=sumR_c(1);
            
        end
    end
end

%agg index
aggIDX_Q=sum((R_grp./repmat(sum(R_grp,1),g,1)).*IDX_Q,1);
aggIDX_P=sum((R_grp./repmat(sum(R_grp,1),g,1)).*IDX_P,1);

%y-o-y change in the agg index
for k=1:T-4
    aggIDX_Q_yoy(k)=sum(aggIDX_Q(k:k+3))/4;
    aggIDX_P_yoy(k)=sum(aggIDX_P(k:k+3))/4;
end

FS=12;%FontSize
LW=2.5;%LineWidth
tline=2007.25:0.25:2011.0;

%Domestic only figure
figure;
plot(tline,aggIDX_Q_yoy,'-',tline,aggIDX_P_yoy,'--','LineWidth',LW)
set(gca,'FontSize',FS)
hline(0,'k')
ylabel('Components of \DeltaW_t index, y-o-y change')
legend('Quantity','Price','location','northeast')
xlim([2007.25 2011.0])