%This code generates Figure 11
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clear all
load Data\dataAER_RR allLVAdata_dropIN_4secUV
MTX=allLVAdata_dropIN_4secUV;

sec_level=4;
hs=9;
T=(size(MTX,2)-hs)/2;

%loop to prepare, collect and plot the price level data
avgP_D_cum = [];
avgP_F_cum = [];

for prodlev=sec_level%0:4 %Choose product level
    
    list=floor(1000/(10^(4-prodlev))):floor(9999/(10^(4-prodlev)));
    
    for ProdDef=list%list of feasible sectors
        
        %restrict MTX to the particular product
        MCtree_X=ProdDef*(10^(4-prodlev)):...
            ProdDef*(10^(4-prodlev))+floor(0.9999*(10^(4-prodlev)));
        MTX2=MTX(ismember(MTX(:,2),MCtree_X),:);
        
        if ~isempty(MTX2)==1%proceed only if MTX not empty
            N=size(MTX2,1);
            Q=MTX2(:,hs+1:hs+T)';
            P=MTX2(:,hs+T+1:hs+2*T)';
            Rmtx=P.*Q;
            s=Rmtx./repmat(nansum(Rmtx,2),1,N);
            F_id=find(~ismember(MTX2(:,9),[101 941]));
            D_id=find(ismember(MTX2(:,9),[101 941]));
            sD=nansum(s(:,D_id),2);
            sF=nansum(s(:,F_id),2);
            
            Puv_Did=nansum(Rmtx(:,D_id),2)./nansum(Q(:,D_id),2);
            Puv_Fid=nansum(Rmtx(:,F_id),2)./nansum(Q(:,F_id),2);
            Inum_D=sum(~isnan(Rmtx(:,D_id)),2);
            Inum_F=sum(~isnan(Rmtx(:,F_id)),2);
            avgP_D = nanmean(Rmtx(:,D_id)./Q(:,D_id),2);
            avgP_F = nanmean(Rmtx(:,F_id)./Q(:,F_id),2);
            
            %colect relevant data
            avgP_D_cum = [avgP_D_cum avgP_D];
            avgP_F_cum = [avgP_F_cum avgP_F];
        end
    end
end
var1c=log(avgP_F_cum./avgP_D_cum);
[T,G]=size(var1c);

figure;
FS=14;%FontSize
LW=2.5;%LineWidth
VAR1=reshape(var1c,T*G,1);
VAR2=histc(reshape(var1c,T*G,1),-2.665:0.13:2.6);
bar(-2.665:0.13:2.6,VAR2/sum(VAR2));
set(gca,'FontSize',FS)
xlim([-3 3])
vline(0,'k')
ylabel('Density','interpreter','latex')
xlabel(...
'Within-group average imported/domestic unit price, $\ln(\bar{p}^F_{ig}/\bar{p}^D_{ig})$',...
    'interpreter','latex' )