% This code generates Figure 13
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear all
load Data/dataAER_RR
MTX=allLVAdata_dropIN_4secUV;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
hs=9;
T=(size(MTX,2)-hs)/2;
P=MTX(:,hs+T+1:hs+2*T);
Q=MTX(:,hs+1:hs+T);
Rmtx=P.*Q;
R_ALL=nansum(Rmtx,1)';

prodlev=4;%choose sectoral detail
list=floor(1000/(10^(4-prodlev))):floor(9999/(10^(4-prodlev)));

g=0;
for ProdDef=list%list of feasible sectors
    
    %restrict MTX to the particular product
    MCtree_X=ProdDef*(10^(4-prodlev)):...
        ProdDef*(10^(4-prodlev))+floor(0.9999*(10^(4-prodlev)));
    MTX2=MTX(ismember(MTX(:,2),MCtree_X),:);
    
    if ~isempty(MTX2)==1%proceed only if MTX not empty
        
        N=size(MTX2,1);
        Q=MTX2(:,hs+1:hs+T);
        P=MTX2(:,hs+T+1:hs+2*T);
        origin=MTX2(:,hs);
        Rmtx=P.*Q;
        s_grp_tot=nansum(nansum(Rmtx,1))/sum(R_ALL);
        
        %restrict data to relevant groups
        for t=1:T-1
            cid_D=intersect(find(~isnan(P(:,t).*P(:,t+1))),...
                find(ismember(origin,[101 941])));%continuing id + D origin
            cid_F=intersect(find(~isnan(P(:,t).*P(:,t+1))),...
                find(~ismember(origin,[101 941])));%continuing id + F origin
            cid=sort([cid_D;cid_F]); %all continuing id
            temp(t)=length(cid);
            temp_D(t)=length(cid_D);
            temp_F(t)=length(cid_F);
        end
        
        if min(temp_D)>=1 && min(temp_F)>=1
        g=g+1;
            
            %compute UV decomposition for continuing/exiting/entering items
            for t=1:T-1
                cid_D=intersect(find(~isnan(P(:,t).*P(:,t+1))),...
                    find(ismember(origin,[101 941])));%continuing id + D origin
                cid_F=intersect(find(~isnan(P(:,t).*P(:,t+1))),...
                    find(~ismember(origin,[101 941])));%continuing id + F origin
                cid=sort([cid_D;cid_F]); %all continuing id 
                ovlp=length(cid);
                
                %quantities
                %%%%%%%%%%%%%%%%%%
                %%all
                Q_c=Q(cid,[t t+1]);
                sumQ_c=sum(Q_c,1);
                Qw_c=Q_c./repmat(sumQ_c,[ovlp,1]);
                %%Domestic
                Q_c_D=Q(cid_D,[t t+1]);
                sumQ_c_D=sum(Q_c_D,1);
                Qw_c_D=Q_c_D./repmat(sumQ_c_D,[length(cid_D),1]);
                %%Foreign
                Q_c_F=Q(cid_F,[t t+1]);
                sumQ_c_F=sum(Q_c_F,1);
                Qw_c_F=Q_c_F./repmat(sumQ_c_F,[length(cid_F),1]);
                
                %agg unit values
                %%%%%%%%%%%%%%%%%%
                %%all
                P_c=P(cid,[t t+1]);
                agguvP_c=sum(Qw_c.*P_c,1);
                %%Domestic
                P_c_D=P(cid_D,[t t+1]);
                agguvP_c_D=sum(Qw_c_D.*P_c_D,1);
                Pdev_c_D_FD=agguvP_c_D./agguvP_c;%relative pD
                %%Foreign
                P_c_F=P(cid_F,[t t+1]);
                agguvP_c_F=sum(Qw_c_F.*P_c_F,1);
                Pdev_c_F_FD=agguvP_c_F./agguvP_c;%relative pF
                
                %expenditure shares
                %%%%%%%%%%%%%%%%%%%%
                %%all
                R_c=Rmtx(cid,[t t+1]);%c stands for "continuing"
                sumR_c=sum(R_c,1);
                %%domestic
                R_c_D=Rmtx(cid_D,[t t+1]);
                sumR_c_D=sum(R_c_D,1);
                Rw_c_D_FD=sumR_c_D./sumR_c;
                %%foreign
                R_c_F=Rmtx(cid_F,[t t+1]);
                sumR_c_F=sum(R_c_F,1);
                Rw_c_F_FD=sumR_c_F./sumR_c;                
                
                %Useful later 
                Rw_c_FD=[Rw_c_D_FD;Rw_c_F_FD];
                Pdev_c_FD=[Pdev_c_D_FD;Pdev_c_F_FD];
                uvPdev_c_FDdiff_mtx(g,t)=agguvP_c_F(1)/agguvP_c_D(1);
                R_grp(g,t)=sumR_c(1);
                
                %F/D-composite indexes
                %%%%%%%%%%%%%%%%%%%%
                IDX_ES_FD(g,t)=sum(log(Rw_c_FD(:,2)./Rw_c_FD(:,1)).*log(Pdev_c_FD(:,1)),1);

            end
        end
    end
end

%IDing pF>pD aand pD>pF product groups:
Fplus_id=uvPdev_c_FDdiff_mtx>1 & uvPdev_c_FDdiff_mtx<1000000;
Dplus_id=uvPdev_c_FDdiff_mtx>0 & uvPdev_c_FDdiff_mtx<1;
R_F=Fplus_id;
R_D=Dplus_id;

%agg indexes
aggIDX_ES_F=nansum(((R_grp.*R_F)./...
    repmat(sum((R_grp.*R_F),1),g,1)).*IDX_ES_FD,1);
aggIDX_ES_D=nansum(((R_grp.*R_D)./...
    repmat(sum((R_grp.*R_D),1),g,1)).*IDX_ES_FD,1);

%y-o-y change in the agg index
for k=1:T-4
    aggIDX_ES_F_yoy(k)=sum(aggIDX_ES_F(k:k+3))/4;
    aggIDX_ES_D_yoy(k)=sum(aggIDX_ES_D(k:k+3))/4;
end

FS=12;%FontSize
LW=2.5;%LineWidth
tline=2007.25:0.25:2011.0;

figure;
plot(tline,100*aggIDX_ES_F_yoy,'-',...
    tline,100*aggIDX_ES_D_yoy,'--',...
    'LineWidth',LW)
set(gca,'FontSize',FS)
hline(0,'k')
l = legend('Product groups with $p^F_g>p^D_g$',...
    'Product groups with $p^D_g>p^F_g$');
set(l, 'Interpreter', 'latex')
ylabel('\DeltaW^{F/D}_t index, y-o-y change')
ylim([-2.5 2.5])
xlim([2007.25 2011.0])