%This code generates Figure 2
%compares monthly food CPI in scanner data with comparable series from
%Statistical office
clear all

load Data\dataAER_RR allLVAdata_dropIN obs Mdates
load Data\csbdata

CPI=CPIdata./(CPIdata(:,1)*ones(1,obs)*1.09);
MTX2=allLVAdata_dropIN;

%exludes flowers, baby, pets, pharma and deposits, since note in food CPI
MCtree_fb=[1000:1699 2000:3499 4000:4499 4800:5099 5400:5499];                     
MTX2=MTX2(ismember(MTX2(:,2),MCtree_fb),:);

%restrict to HD stores to proxy for the limited sample of most frequently 
%purchasedcore products covered in CPI survey
MTX3=MTX2(MTX2(:,1)==2,:);
[~,~,~,~,dpG]=pinx_fn(MTX3,obs,9,1);
pG_HD=cumprod([1 dpG]);

FS=12;%FontSize
LW=2.5;%LineWidth

figure
plot(datenum(Mdates,'mmmyy'),pG_HD,...
    datenum(Mdates,'mmmyy'),CPI(1,:),'-.','LineWidth',LW)
datetick('x',12);
set(gca,'FontSize',FS)
ylabel('Price index','FontSize',FS);
legend('Scanner data','Official CPI for F&B','location','SouthEast')