%This code generates Figure 3
%compares monthly imports with relevant scanner counterpart. Plots are
%quarterly to limit seasonality.
clear all

load Data\dataAER_RR
MTX=allLVAdata_dropIN;

%exludes flowers, baby products, pet products, pharma, deposits and tabaco (because not in
%agg. food import data)
MCtree_fb=[1000:1699 2000:3599 3700:3799 4000:4499 4800:5099];                   
MTX=MTX(ismember(MTX(:,2),MCtree_fb),:);

%keep only foreign goods
MTX=MTX(~ismember(MTX(:,9),[100 101 941]),:);
[sumRmtx]=pinx_fn(MTX,obs,9,1);

%load import data from Julian's file
m = xlsread('Data/FoodImportsEuro_GITS_BEC.csv');
m=m(89:149,3);

%aggregate monthly data into quarterly (19 overlaping quarters: Q2_06-Q1_11)
multmtx=[];
for j=1:19
    multmtx=blkdiag(multmtx,ones(1,3));
end
ImpDataQ=multmtx*m(3:end-2);
ScnDataQ=multmtx*sumRmtx(3:end-2)';

t1=11;
t2=15;
FS=12;%FontSize
LW=2.5;%LineWidth
tline=2006.5:0.25:2011.0;

figure
plot(tline,log(ScnDataQ/ScnDataQ(7)),'-',...
    tline,log(ImpDataQ/ImpDataQ(7)),'-.','LineWidth',LW)
set(gca,'FontSize',FS)
xlim([2006.5 2011.0])
ylabel('Value index')
legend('Scanner data','Customs data','location','NorthWest')