%This code generates Figures 5,6 and 8
%examins the contribution of within and accross product group
%expenditure switching to the total ES
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clear all
load Data/PandQdata

FS=12;%FontSize
LW=2.5;%LineWidth
tline=2007.25:0.25:2011.0;
scle=1e+2; 

%define store type
m=0;
DATAMTX=DATAMTX(DATAMTX(:,3)==m,:);
DATAMTXsum=DATAMTXsum(DATAMTXsum(:,2)==m,:);
j=1000:9999;
DATA=DATAMTX(ismember(DATAMTX(:,2),j),:);
DATAMTXsum=DATAMTXsum(ismember(DATAMTXsum(:,1),j),:);

%%%%%%%%%%%%%%%%%%%%%%%
seclist=unique(DATA(:,2));
N=length(seclist);
for i=1:N
    MTX=DATA(DATA(:,2)==seclist(i),:);
    dlp(:,i)=MTX(2:end,4);
    dlpF(:,i)=MTX(2:end,9);
    s(:,i)=MTX(:,7);
    sH(:,i)=MTX(:,14);
    sF(:,i)=MTX(:,15);
end

%Include extensive margin, so that decomposition components add to zero.
for i=1:N
    for t=1:20
        if sH(t,i)==100
            sF(t,i)=0;
        end
        if isnan(sF(t,i))
            sF(t,i)=0;
        end
        if isnan(s(t,i))
            s(t,i)=0;
        end
    end
end

%decomposition at 4-digit level
s=s/100;
sF=sF/100;
wF=(s.*sF)./repmat(nansum(s.*sF,2),1,N);
ES=nansum(s.*sF,2);
dES=ES(5:end)-ES(1:end-4);
dwithin=nansum((sF(5:end,:)-sF(1:end-4,:)).*s(1:end-4,:),2);
dacross=nansum((s(5:end,:)-s(1:end-4,:)).*sF(1:end-4,:),2);
dboth=nansum((s(5:end,:)-s(1:end-4,:)).*(sF(5:end,:)-sF(1:end-4,:)),2);

figure;
plot(tline,dES,'-',tline,dwithin,'-.',tline,dacross,'--','LineWidth',LW)
%plot(tline,dES,'-','LineWidth',LW)
set(gca,'FontSize',FS)
hline(0,'k-')
xlim([2007.25 2011.0])
ylim([-0.04 0.03])
ylabel('Y-o-y change in import expenditure share')
legend('Aggregate','Within','Across')

sF_temp=sF;
sF_temp(sF_temp==0 | sF_temp==1)=nan;
dsF_g=log(sF_temp(10+4,:))-log(sF_temp(10,:));
dsF2_g=sF_temp(10+4,:)-sF_temp(10,:);

figure;

[n,xout]=hist(dsF_g,[-2:0.1:2]);%mean over time for each group
bar(xout,n)
set(gca,'FontSize',14)
xlabel('Import expenditure share growth rate, $\ln(\varphi^F_{gt}/\varphi^F_{gk})$','interpreter','latex')
ylabel('Frequency','interpreter','latex')
xlim([-2 2])

%Corresponding price stats
p=exp(cumsum([zeros(1,N);dlp],1));
pF=exp(cumsum([zeros(1,N);dlpF],1));
dpF_p=log(pF(10+4,:)./p(10+4,:))-log(pF(10,:)./p(10,:));

figure;
plot(wF(10,:),dpF_p,'o','LineWidth',1,'Color',[0 0.5 0],'MarkerSize',2.5)
set(gca,'FontSize',FS)%,'XScale','log')
xlim([-0.0005 0.06])
hline(0,'k-')
ylim([-0.30 0.30])
xlabel('Share in food imports, w^F_{gt}/w^F_t')
ylabel('Change in relative price, \Deltalog(P^{F}_{gt}/P_{gt})')