%This code generates Figure A3
%examins the contribution of within and accross product group
%expenditure switching to the total ES
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

clear all
load Data/PandQdata  

FS=12;%FontSize
LW=2.5;%LineWidth
tline=2007.25:0.25:2011.0;
scle=1e+2;

%%%%%%%%%%%%%%%%%%%%%%
j=1000:9999;
DATAMTX=DATAMTX(ismember(DATAMTX(:,2),j),:);
DATAMTXsum=DATAMTXsum(ismember(DATAMTXsum(:,1),j),:);
seclist=unique(DATAMTXsum(:,1));
N=length(seclist);

%define store type
d=1;
for store=[0 1 2 3]
    DATA=DATAMTX(DATAMTX(:,3)==store,:);
    DATAMTXsum2=DATAMTXsum(DATAMTXsum(:,2)==store,:);   
    %%%%%%%%%%%%%%%%%%%%%%%
    for i=1:N
        MTX=DATA(DATA(:,2)==seclist(i),:);
        if isempty(MTX)==0
            rev(:,i,d)=MTX(:,6);
            revH(:,i,d)=MTX(:,12);
            revF(:,i,d)=MTX(:,13);
            s(:,i,d)=MTX(:,7);
            sH(:,i,d)=MTX(:,14);
            sF(:,i,d)=MTX(:,15);
        end
    end
    d=d+1;
end

%decomposition at 4-digit level
s=s/100;
sF=sF/100;
m(:,:,1)=rev(:,:,2)./rev(:,:,1);
m(:,:,2)=rev(:,:,3)./rev(:,:,1);
m(:,:,3)=rev(:,:,4)./rev(:,:,1);
sFs=sF(:,:,2:4);

for i=1:N
    for t=1:20
        if isnan(s(t,i,1))
            s(t,i,1)=0;
        end
        if isnan(sF(t,i,1))
            sF(t,i,1)=0;
        end
        for v=1:3
            if isnan(m(t,i,v))
                m(t,i,v)=0;
            end
            if isnan(sFs(t,i,v))
                sFs(t,i,v)=0;
            end
        end
    end
end

t=5:20;
m_base=0.5*(m(t-4,:,:)+m(t,:,:));
sFs_base=0.5*(sFs(t-4,:,:)+sFs(t,:,:));
s_base=0.5*(s(t-4,:,1)+s(t,:,1));
dwithinS=nansum((sFs(t,:,:)-sFs(t-4,:,:)).*m_base,3);
dacrossS=nansum((m(t,:,:)-m(t-4,:,:)).*sFs_base,3);
dbothS=nansum((sFs(t,:,:)-sFs(t-4,:,:)).*(m(t,:,:)-m(t-4,:,:)),3);
d_withinG_withinS=nansum(s_base.*dwithinS,2);
d_withinG_acrossS=nansum(s_base.*dacrossS,2);
d_2nd_order=nansum(s_base.*dbothS,2);
d_within=nansum((sF(t,:,1)-sF(t-4,:,1)).*s_base,2);

dwithinS1=(sFs(t,:,1)-sFs(t-4,:,1)).*m_base(:,:,1);
dwithinS2=(sFs(t,:,2)-sFs(t-4,:,2)).*m_base(:,:,2);
dwithinS3=(sFs(t,:,3)-sFs(t-4,:,3)).*m_base(:,:,3);
d_withinG_withinS1=nansum(s_base.*dwithinS1,2);
d_withinG_withinS2=nansum(s_base.*dwithinS2,2);
d_withinG_withinS3=nansum(s_base.*dwithinS3,2);

figure;
plot(tline,d_within,'-',tline,d_withinG_withinS1+...
   d_withinG_withinS2+d_withinG_withinS3,'-.',...
    tline,d_withinG_acrossS,'--','LineWidth',LW)
set(gca,'FontSize',FS)
hline(0,'k')
xlim([2007.25 2011.0])
ylabel('Y-o-y change in expenditure share')
legend('Total within',...
    'Within groups/within store type','Within groups/across store type')